(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 100 on page 418
   Depth-First Search *)

  let iter_dfs f g s =
    let visited = H.create () in
    let rec visit v =
      if not (H.mem visited v) then begin
        H.add visited v ();
        f v;
        iter_succ visit g v
      end
    in
    visit s
