(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 29 on page 193
   Update Operations on Ropes *)

  let set t i c =
    let n = length t in
    if i < 0 || i >= n then invalid_arg "set";
    sub t 0 i ++ make 1 c ++ sub t (i + 1) (n - i - 1)

  let insert t i r =
    let n = length t in
    if i < 0 || i > n then invalid_arg "insert";
    sub t 0 i ++ r ++ sub t i (n - i)

  let insert_char t i c =
    insert t i (make 1 c)

  let delete_char t i =
    let n = length t in
    if i < 0 || i >= n then invalid_arg "delete_char";
    sub t 0 i ++ sub t (i + 1) (n - i - 1)
