(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 39 on page 226
   Searching in an AVL Dictionary *)

  let rec find k = function
    | Empty ->
	raise Not_found
    | Node (l, k', v, r, _) ->
	let c = X.compare k k' in
	if c = 0 then v else if c < 0 then find k l else find k r
