(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 46 on page 238
   Searching in an Associative Hash Table *)

  let find x h =
    let rec lookup = function
      | [] -> raise Not_found
      | (k, v) :: _ when X.equal x k -> v
      | _ :: b -> lookup b
    in
    let i = bucket_of x h in
    lookup h.buckets.(i)
