(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 65 on page 286
   Minimal signature for persistent priority queues *)

module type PersistentPriorityQueue = sig
  type t
  type elt
  val empty : t
  val is_empty : t -> bool
  val add : elt -> t -> t
  val get_min : t -> elt
  val remove_min : t -> t
end
