(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 67 on page 298
   Minimal signature for graphs with integer vertices *)

  type vertex = int
  type t

  val create : int -> t
  val nb_vertex : t -> int

  val mem_edge : t -> vertex -> vertex -> bool
  val add_edge : t -> vertex -> vertex -> unit
  val remove_edge : t -> vertex -> vertex -> unit

  val iter_succ : (vertex -> unit) -> t -> vertex -> unit
  val iter_edge : (vertex -> vertex -> unit) -> t -> unit
