(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 73 on page 326
   Structure of a zipper on a list *)

  type 'a zipper = { left: 'a list; right: 'a list; }

  let of_list l =
    { left = []; right = l }

  let move_right z = match z.right with
    | [] -> invalid_arg "move_right"
    | x :: r -> { left = x :: z.left; right = r }

  let move_left z = match z.left with
    | [] -> invalid_arg "move_left"
    | x :: l -> { left = l; right = x :: z.right }

  let to_list z =
    List.rev_append z.left z.right

  let insert z x =
    { z with left = x :: z.left }

  let delete_left z =  match z.left with
    | [] -> invalid_arg "delete_left"
    | _ :: l -> { z with left = l }

  let delete_right z =  match z.right with
    | [] -> invalid_arg "delete_right"
    | _ :: r -> { z with right = r }
