(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 81 on page 348
   Modular Arithmetic *)

  let () = assert (0 < m && m <= max_int/2 + 1)

  let of_int x = let r = x mod m in if r < 0 then r + m else r

  let add x y = let r = x + y in if r >= m then r - m else r

  let sub x y = let r = x - y in if r < 0 then r + m else r
