(********************************************************************)
(*  OCaml code from the book ``Learn Programming with OCaml''       *)
(*  See https://usr.lmf.cnrs.fr/lpo/                                *)
(*                                                                  *)
(*  Sylvain Conchon and Jean-Christophe Filliâtre                   *)
(*  Copyright 2025 Université Paris-Saclay and CNRS                 *)
(*                                                                  *)
(*  Openly licensed via CC BY SA 4.0                                *)
(*  See https://creativecommons.org/licenses/by-sa/4.0/deed.en      *)
(********************************************************************)

(* Program 91 on page 381
   Quicksort on lists *)

  let rec partition ((left, right) as acc) p = function
    | [] -> acc
    | x :: s when le x p ->
        partition (x :: left, right) p s
    | x :: s -> 
        partition (left, x :: right) p s

  let rec quicksort = function
    | [] ->
        []
    | p :: s ->
        let (left, right) = partition ([], []) p s in
        (quicksort left) @ (p :: quicksort right)
  